Subject: Re: bug#62949: libgcrypt version in core-updates

From: Andreas Enge <[email-masked]>
Date: Wed, 19 Apr 2023 20:19:02 +0200

Am Wed, Apr 19, 2023 at 06:37:08PM +0200 schrieb Ludovic Courtès:
> Given that the ‘guix’ package builds fine on ‘core-updates’, it’s most
> likely a build environment issue.
> What does ‘config.log’ say?

My environment is Debian on aarch64, with Guix as the package manager.
So it is possible that the Debian environment disturbs what is happening;
but I see the problem depending on whether I install the new or the old
libgcrypt from Guix.

Here are lines from config.log with things related to crypto in them:
configure:8987: checking whether Guile-Gcrypt is available and recent enough
configure:9005: result: yes
...
configure:9062: WARNING: The Guile-Lib requirement was not satisfied (>= 0.2.7);
Some features such as the Go importer will not be usable.
    (not crypto related, but suspicious)
...
configure:9435: checking for libgcrypt-config
configure:9458: found /home/andreas/.guix-profile/bin/libgcrypt-config
configure:9470: result: /home/andreas/.guix-profile/bin/libgcrypt-config
configure:9478: checking libgcrypt's library directory
configure:9490: result: /gnu/store/2xsdih7m18d0f2kiicxrh9pwinjfwzkj-libgcrypt-1.10.1/lib
configure:10900: checking for gcry_md_open in -lgcrypt
configure:10922: g++ -o conftest -g -O2    conftest.cpp -lgcrypt   >&5
ld: /home/andreas/.guix-profile/lib/libgpg-error.so.0: undefined reference to [email-masked]' 
collect2: error: ld returned 1 exit status
configure:10922: $? = 1
configure: failed program was:
...
configure:10932: result: no
configure:10941: checking for gcrypt.h
configure:10941: g++ -c -g -O2  conftest.cpp >&5
configure:10941: $? = 0
configure:10941: result: yes
configure:10950: error: GNU libgcrypt not found; please install it.

So this is not related to libgcrypt, but to libgpg-error.so linked with an old
glibc; we should be at 2.35 in core-updates, no?

Strangely enough, when I do ldd on /home/andreas/.guix-profile/lib/libgpg-error.so.0
then it is linked with /gnu/store/...-glibc-2.35/lib/libc.so.

Where does this [email-masked] come from?

I tried "guix shell --pure -D guix" and then "./configure", but the result
is the same.

I will try again on my pure Guix machine.

Andreas